{$APPTYPE CONSOLE}
program Project1;
uses
  Classes,
  PAXCOMP_CONSTANTS,
  PAXCOMP_KERNEL,
  PaxCompiler, PaxProgram, PaxRegister, IMPORT_Common;

var
  K: Integer = 0;
procedure Test(Module: String; X, Y: Integer);
var
  PaxCompiler1: TPaxCompiler;
  PaxProgram1: TPaxProgram;
  PaxPascalLanguage1: TPaxPascalLanguage;
  I: Integer;
  L: TStringList;
  S: String;
begin
  Inc(K);
  writeln('Test ', K);
  writeln('-----------------------------------');

  L := TStringList.Create;
  PaxCompiler1 := TPaxCompiler.Create(nil);
  PaxProgram1 := TPaxProgram.Create(nil);
  PaxPascalLanguage1 := TPaxPascalLanguage.Create(nil);
  try
    PaxCompiler1.RegisterLanguage(PaxPascalLanguage1);

    PaxCompiler1.AddModule(Module, 'Pascal');
    PaxCompiler1.AddCodeFromFile(Module, Module + '.pas');
    I := PaxCompiler1.FindDeclaration(Module, X, Y);
    if I > 0 then
    begin
      S := PaxCompiler1.GetModuleName(I);
      writeln(S);

      I := PaxCompiler1.GetPosition(I);

      L.LoadFromFile(S + '.pas');
      S := L.Text;
      S := Copy(S, I + 1, 1);
      writeln(S);
      writeln(I);
    end
    else
    begin
      writeln(PaxCompiler1.ErrorMessage[0]);
      writeln(PaxCompiler1.ErrorLineNumber[0]);
      writeln(PaxCompiler1.ErrorLine[0]);
    end;
  finally
    PaxCompiler1.Free;
    PaxProgram1.Free;
    PaxPascalLanguage1.Free;
    L.Free;
  end;
end;
begin
{
  Test('script1', 8, 3);
  Test('script2', 4, 5);
  Test('script3', 4, 5);
  Test('script4', 8, 3);
}
//  Test('script5', 8, 3);
//  Test('script6', 4, 5);
//  Test('script7', 5, 3);
//  Test('script8', 8, 5);
//  Test('script9', 8, 3);
//  Test('script10', 19, 8);
  Test('script11', 8, 10);

  writeln('Press any key...');
  Readln;
end.
